/* 
 *   Creation Date: <1999/02/22 22:46:22 samuel>
 *   Time-stamp: <2003/07/27 14:42:05 samuel>
 *   
 *	<debugger.h>
 *	
 *	World interface of the debugger
 *   
 *   Copyright (C) 1999, 2000, 2001, 2002, 2003 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#ifndef _H_DEBUGGER
#define _H_DEBUGGER

extern void 	debugger_init( void );
extern void 	debugger_cleanup( void );

extern int	debugger_enabled( void );
extern int	debugger_attached( void );

/*******************************************/
/*	montior.c / nub.c		   */
/*******************************************/

extern void 	refresh_debugger_window( void );
extern void 	refresh_debugger( void );
extern void 	redraw_inst_win( void );
extern int	debugger_in_68k_mode( void );
extern void	debugger_nub_poll( void );

/* debug actions */
enum{  
	kDbgNOP=0, kDbgGo, kDbgGoRFI, kDbgStep, kDbgExit, kDbgStop, kDbgGoUser
};


/*******************************************/
/*	cmdline.c / nub.c		   */
/*******************************************/

/* put functions used exclusively in debugger mode in the dbg section */
#define __dbg	__attribute__ ((__section__ (".moldbg")))

typedef struct {
	const char	*name;
	int		(*func)( int argc, char **argv );
	const char	*help;
} dbg_cmd_t;

typedef int	(*dbg_cmd_fp)( int argc, char **argv );
extern void	add_cmd( const char *cmdname, const char *help, int dummy, dbg_cmd_fp func );
extern void	add_dbg_cmds( dbg_cmd_t *table, int tablesize );

/* for debugging */
#define HARD_BREAKPOINT \
	({ printm("Hardcoded breakpoint in '"__FILE__"'\n"); stop_emulation(); })


/*******************************************/
/*	mmu_cmds.c			   */
/*******************************************/

extern int	__dbg get_inst_context( void );
extern int	__dbg get_data_context( void );
extern int	__dbg ea_to_lvptr( ulong ea, int context, char **lvptr, int data_access );

#endif   /* _H_DEBUGGER */
